library IEEE;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity COMPARE_THRESHOLD is
generic ( n: integer; -- 5
          m: integer); -- 6
port( ACTIVATION_ZEROS: in std_logic_vector(n-1 downto 0);
      WEIGHT_ZEROS: in std_logic_vector(n-1 downto 0);
      THRESHOLD_ZEROS: in std_logic_vector(m-1 downto 0);
      APPROXIMATE: out std_logic);
end COMPARE_THRESHOLD;

architecture behavioural of COMPARE_THRESHOLD is

signal SUM_LEADING_ZEROS: std_logic_vector (m-1 downto 0);
signal EX_ACTS_ZEROS: std_logic_vector(m-1 downto 0);
signal EX_WEIGHTS_ZEROS: std_logic_vector(m-1 downto 0);

begin
--EXTEND THE SIGN TO AVOID OVERFLOW
EX_ACTS_ZEROS <= '0'&ACTIVATION_ZEROS;
EX_WEIGHTS_ZEROS <= '0'&WEIGHT_ZEROS;

SUM_LEADING_ZEROS <= EX_ACTS_ZEROS + EX_WEIGHTS_ZEROS;

process(SUM_LEADING_ZEROS)
begin
if SUM_LEADING_ZEROS >= THRESHOLD_ZEROS then
APPROXIMATE <= '0';
else
APPROXIMATE <= '1';
end if;
end process;

end behavioural;