library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all; 
use ieee.std_logic_signed.all;
use ieee.std_logic_textio.all;

library std;
use std.textio.all;

entity WEIGHTS_MEMORY_ROM is
generic (m: integer:=10; n: integer:=8; k: integer:=18);
port(CLK: in std_logic;
     RESET: in std_logic;
     OE: in std_logic;  
     W_0: out std_logic_vector(k-1 downto 0);
     W_1: out std_logic_vector(k-1 downto 0);
     W_2: out std_logic_vector(k-1 downto 0);
     W_3: out std_logic_vector(k-1 downto 0);
     W_4: out std_logic_vector(k-1 downto 0);
     W_5: out std_logic_vector(k-1 downto 0);
     W_6: out std_logic_vector(k-1 downto 0);
     W_7: out std_logic_vector(k-1 downto 0);
     W_8: out std_logic_vector(k-1 downto 0);
     TH: out std_logic_vector(k-1 downto 0));
     end WEIGHTS_MEMORY_ROM;   

architecture behavioural of WEIGHTS_MEMORY_ROM is

type ROM_ARRAY is array (0 to m-1) of std_logic_vector(k-1 downto 0);        

impure function read_data_ROM return ROM_ARRAY is                   
 
    file fp_1: text open READ_MODE is "/home/thesis/erik.anzalone/SYNTHESIS/APPROXIMATION_SKIPPING_ARCHITECTURE/INPUTS/INPUTS3/WEIGHTS1/weights_channel1.txt";
    file fp_2: text open READ_MODE is "/home/thesis/erik.anzalone/SYNTHESIS/APPROXIMATION_SKIPPING_ARCHITECTURE/INPUTS/INPUTS3/WEIGHTS1/weights_channel2.txt";
    file fp_3: text open READ_MODE is "/home/thesis/erik.anzalone/SYNTHESIS/APPROXIMATION_SKIPPING_ARCHITECTURE/INPUTS/INPUTS3/WEIGHTS1/weights_channel3.txt";
    variable buf_1: line;
    variable buf_2: line;					     				 
    variable buf_3: line;
 					     				 
    variable valore_1 : std_logic_vector(n-1 downto 0);
    variable valore_2 : std_logic_vector (n-1 downto 0);
    variable valore_3 : std_logic_vector (n-1 downto 0);
   		     
    variable ROM: ROM_ARRAY := (others=>(others=>'0'));	         
    variable readvalue_1: std_logic_vector(n-1 downto 0);	
    variable readvalue_2: std_logic_vector(n-1 downto 0);
    variable readvalue_3: std_logic_vector(n-1 downto 0);	
    
    variable wordmemory: std_logic_vector(k-1 downto 0):=(others => '0');         
    variable I: integer range 0 to m;

begin
        readloop: for t in 0 to m-1 loop
       
              
                   readline(fp_1, buf_1); -- Legge il valore puntato da fp_1 e lo memorizza in buf_1
	           readline(fp_2, buf_2); -- Legge il valore puntato da fp_2 e lo memorizza in buf_2
	           readline(fp_3, buf_3); -- Legge il valore puntato da fp_3 e lo memorizza in buf_3
                   
			   
			   hread(buf_1, valore_1);	--Il valore in buf_R  esadecimale e viene convertito in std_logic_vector 
			   hread(buf_2, valore_2);	--Il valore in buf_Y  esadecimale e viene convertito in std_logic_vector 
			   hread(buf_3, valore_3);	--Il valore in buf_B  esadecimale e viene convertito in std_logic_vector 
                          			   

                           readvalue_1:= std_logic_vector(signed(valore_1));
			   readvalue_2:= std_logic_vector(signed(valore_2));
			   readvalue_3:= std_logic_vector(signed(valore_3));
                          
	
      -- WRITING WORD MEMORY THAT CONTAINS FILTERS OF CHANNEL1, CHANNEL2, CHANNEL3		   
               wordmemory(k-1 downto k-n+2):= readvalue_1(n-1)&readvalue_1(n-4 downto 0);         
               wordmemory(k-n+1 downto k-n-4):= readvalue_2(n-1)&readvalue_2(n-4 downto 0);    
	       wordmemory(k-n-5 downto 0):= readvalue_3(n-1)&readvalue_3(n-4 downto 0);   
               
	
               ROM(I):= wordmemory;	
               I := I+1; 
              
              
 
	end loop readloop;
	return ROM;
end function;
	

constant ROM: rom_array:= read_data_ROM;

-- reading process from WEIGHTS_MEMORY_ROM( 9 values in the first clock cycle)

begin

read_process: process (CLK,RESET,OE)  

	variable address : integer range 0 to m;
	begin
		if RESET = '1' then
			 address := 0;
			 W_0 <= (others=>'0');
			 W_1 <= (others=>'0');
			 W_2 <= (others=>'0');
			 W_3 <= (others=>'0');
			 W_4 <= (others=>'0');
			 W_5 <= (others=>'0');
			 W_6 <= (others=>'0');
			 W_7 <= (others=>'0');
			 W_8 <= (others=>'0');
                         TH <= (others=> '0');
		elsif (CLK'event and CLK = '1') then
               
			 if OE = '1' then
				if address = 0 then 
                                         W_0 <= ROM(0);
					 W_1 <= ROM(1);
					 W_2 <= ROM(2);
					 W_3 <= ROM(3);
					 W_4 <= ROM(4);
					 W_5 <= ROM(5);
					 W_6 <= ROM(6);
					 W_7 <= ROM(7);
	                                 W_8 <= ROM(8);
                                         TH <= ROM(9);
			 else 
		            address:= 0;    
	                         
			   end if;                                  
          end if;
     end if;  

	
end process read_process;


end behavioural;
	
