library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all; 
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_SIGNED.ALL;

entity MUX_2_TO_1 is
generic (m: integer:=9);
port(DATAIN1: in std_logic_vector(m-1 downto 0);
     DATAIN2: in std_logic_vector(m-1 downto 0);
     SEL: in std_logic;
     DATAOUT : out std_logic_vector(m downto 0));
end MUX_2_TO_1;

architecture behavioral of MUX_2_TO_1 is
signal EX_DATAIN1: std_logic_vector (m downto 0);
signal EX_DATAIN2: std_logic_vector (m downto 0);
signal SUM_WEIGHTS: std_logic_vector (m downto 0);

begin
with DATAIN1(m-1) select
EX_DATAIN1 <= '0'&DATAIN1 when '0',
              '1'&DATAIN1 when others;

with DATAIN2(m-1) select
EX_DATAIN2 <= '0'&DATAIN2 when '0',
              '1'&DATAIN2 when others;

SUM_WEIGHTS <= EX_DATAIN1 + EX_DATAIN2;

with SEL select
DATAOUT <= EX_DATAIN1 when '1',
           SUM_WEIGHTS when others;

end behavioral;