library IEEE;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_signed.all;

entity LEADING_ZEROS_COUNTER_16bit_ACTS is
port( DIN: in std_logic_vector(9 downto 0);
      Z: out std_logic_vector(3 downto 0);
      V: out std_logic);
end LEADING_ZEROS_COUNTER_16bit_ACTS;

architecture behavioural of LEADING_ZEROS_COUNTER_16bit_ACTS is 

signal EX_DIN: std_logic_vector(9 downto 0);
signal LONG_EX_DIN: std_logic_vector (15 downto 0);
signal MODULE_CM1: std_logic_vector(9 downto 0);
signal MODULE_CM2: std_logic_vector(9 downto 0);

signal OR_0: std_logic;
signal OR_1: std_logic;
signal OR_2: std_logic;
signal OR_3: std_logic;
signal OR_4: std_logic;
signal OR_5: std_logic;
signal OR_6: std_logic;
signal OR_7: std_logic;
signal OR_8: std_logic;
signal OR_9: std_logic;
signal OR_10: std_logic;
signal OR_11: std_logic;
signal OR_12: std_logic;
signal OR_13: std_logic;
signal OR_14: std_logic;
signal OR_15: std_logic;
signal OR_16: std_logic;
signal OR_17: std_logic;
signal OR_18: std_logic;
signal OR_19: std_logic;
signal OR_20: std_logic;
signal OR_21: std_logic;
signal AND_0: std_logic;
signal AND_1: std_logic;
signal AND_2: std_logic;
signal AND_3: std_logic;
signal AND_4: std_logic;
signal AND_5: std_logic;
signal AND_6: std_logic;
signal AND_7: std_logic;
signal AND_8: std_logic;
signal AND_9: std_logic;
signal AND_10: std_logic;

begin
-- CREATING COMPLEMENT2 OF THE INPUT
MODULE_CM1 <= not(DIN);
MODULE_CM2 <= MODULE_CM1 + 1;

with DIN(9) select
EX_DIN <=  DIN when '0',
           MODULE_CM2 when others;

		  
LONG_EX_DIN <= EX_DIN&"000000";


OR_0 <= LONG_EX_DIN(0) or LONG_EX_DIN(1);
OR_1 <= LONG_EX_DIN(2) or LONG_EX_DIN(3);
OR_2 <= LONG_EX_DIN(4) or LONG_EX_DIN(5);
OR_3 <= LONG_EX_DIN(6) or LONG_EX_DIN(7);
OR_4 <= LONG_EX_DIN(8) or LONG_EX_DIN(9);
OR_5 <= LONG_EX_DIN(10) or LONG_EX_DIN(11);
OR_6 <= LONG_EX_DIN(12) or LONG_EX_DIN(13);
OR_7 <= LONG_EX_DIN(14) or LONG_EX_DIN(15);

OR_8 <= OR_0 or OR_1;
AND_0 <= LONG_EX_DIN(1) and not(OR_1);
OR_12 <= LONG_EX_DIN(3) or AND_0; 
OR_9 <= OR_2 or OR_3;
AND_1 <= LONG_EX_DIN(5) and not(OR_3);
OR_13 <= LONG_EX_DIN(7) or AND_1; 
OR_10 <= OR_4 or OR_5;
AND_2 <= LONG_EX_DIN(9) and not(OR_5);
OR_14 <= LONG_EX_DIN(11) or AND_2; 
OR_11 <= OR_6 or OR_7;
AND_3 <= LONG_EX_DIN(13) and not(OR_7);
OR_15 <= LONG_EX_DIN(15) or AND_3; 

OR_16 <= OR_8 or OR_9;
AND_4 <= OR_1 and not(OR_9);
AND_5 <= OR_12 and not(OR_9);
OR_18 <= OR_3 or AND_4;
OR_19 <= OR_13 or AND_5;

OR_17 <= OR_10 or OR_11;
AND_6 <= OR_5 and not(OR_11);
AND_7 <= OR_14 and not(OR_11);
OR_20 <= OR_7 or AND_6;
OR_21 <= OR_15 or AND_7;

AND_8 <= not(OR_17) and OR_9;
AND_9 <= not(OR_17) and OR_18;
AND_10 <= not(OR_17) and OR_19;
Z(3) <= not(OR_17);
Z(2) <= not(AND_8 or OR_11);
Z(1) <= not(AND_9 or OR_20);
Z(0) <= not(AND_10 or OR_21);
V <= not(OR_17 or OR_16); -- 1 IF THE INPUT IS 0/ 0 IF THE INPUT IS NOT 0 OR A NEGATIVE NUMBER

end behavioural;