library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_signed.all;
use ieee.std_logic_textio.all;

library std;
use std.textio.all;

entity OFF_CHIP_MEMORY_DRAM_CHANNEL2 is
generic (m: integer:=15876; n: integer:=16);
port(CLK: in std_logic;
     RESET: in std_logic;
     WE: in std_logic;
     OE: in std_logic;
     DATA_INPUT: in std_logic_vector(n-1 downto 0);
     END_SIM: out std_logic);
end OFF_CHIP_MEMORY_DRAM_CHANNEL2;

architecture behavioural of OFF_CHIP_MEMORY_DRAM_CHANNEL2 is

type DRAM_ARRAY is array (0 to m-1) of std_logic_vector(n-1 downto 0);        

signal DRAM: DRAM_ARRAY;

begin


-- writing process into ON CHIP MEMORY (if CONTROL UNIT activates WE)

write_process: process (CLK, RESET, WE)
variable address: integer range 0 to m;
begin
if RESET = '1' then  
   address := 0;
   DRAM<=(others=>(others=>'0'));
   
   elsif (CLK'event and CLK = '1') then
          if WE = '1' then 
		     if (address < m) then
			 DRAM(address) <= DATA_INPUT;
             address:= address +1;
             else
			 address:= 0;
			 end if;
		  end if;
		end if;
end process write_process; 

-- reading process from ON CHIP MEMORY( Partial result read if CONTROL UNIT activates OE)


    read_process: process (CLK,RESET)  
 file OFMAP_fp : text open WRITE_MODE is "/home/thesis/erik.anzalone/SYNTHESIS/HIBRYD_EWS-AS_ARCHITECTURE/RESULTS/RESULT3/RESULTSFILTER1/OFMAP_CHANNEL2_TT.txt";
    variable line_out : line;    
    variable I : integer range 0 to m-1 ;	
	begin
		if RESET = '1' then
			 I := 0;
                         END_SIM <= '0';
			 elsif (CLK'event and CLK = '1') then
               
	          if OE = '1' then
		      file_loop: for I in 0 to m-1 loop 
	          write(line_out, conv_integer(signed(DRAM(I))));
              writeline(OFMAP_fp, line_out);
		      
			  end loop;
                          END_SIM <= '1';
        end if;
end if;    
	
    end process read_process;
       

end behavioural;
	
