library IEEE;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_signed.all;

entity PE_STANDARD_EWS_AS is
generic (n: integer; -- 9
         m: integer); --16
port( ACTIVATION: in std_logic_vector(n downto 0);
      WEIGHT: in std_logic_vector(n-4 downto 0);
      ZERO: in std_logic;
      PARTIAL_SUM: in std_logic_vector(m-1 downto 0);
      PARTIAL_RESULT: out std_logic_vector(m-1 downto 0));
end PE_STANDARD_EWS_AS;

architecture behavioural of PE_STANDARD_EWS_AS is

signal PARTIAL_PRODUCT: std_logic_vector (m-1 downto 0);

begin
 
-- MULTIPLIER
with ZERO select
PARTIAL_PRODUCT <= ACTIVATION*WEIGHT when '1',
                  (others => '0') when others;

-- ADDITION
PARTIAL_RESULT <= PARTIAL_PRODUCT + PARTIAL_SUM;

end behavioural;

