//`timescale 1ns

module tb_CONVOLUTER_EWS_APPS ();

   wire CLK_i;
   wire RST_n_i;
   wire EN_AM_R_i;
   wire EN_WM_R_i;
   //wire END_SIM_i;
   wire [23:0] PIX_i;
   wire [23:0] W0_i;
   wire [23:0] W1_i;
   wire [23:0] W2_i;
   wire [23:0] W3_i;
   wire [23:0] W4_i;
   wire [23:0] W5_i;
   wire [23:0] W6_i;
   wire [23:0] W7_i;
   wire [23:0] W8_i;
   wire [23:0] TH_i;
   wire EN_REG_i;
   wire EN_OM0_W_i;
   wire EN_OM0_R_i;
   wire EN_OM1_W_i;
   wire EN_OM1_R_i;
   wire EN_OFF_W_i;
   wire EN_OFF_R_i;
   wire [15:0] M_CH_1_i;
   wire [15:0] M_CH_2_i;
   wire [15:0] M_CH_3_i;
 

      CLK_GEN CG( //.END_SIM(END_SIM_i), 
                  .CLK(CLK_i),
	          .RST_n(RST_n_i));
		  
	ACTIVATIONS_MEMORY_ROM A_MEM(.CLK(CLK_i),
                               .RESET(RST_n_i),
                               .OE(EN_AM_R_i),
                               .DATA_OUTPUT(PIX_i));
	
	WEIGHTS_MEMORY_ROM  W_MEM(.CLK(CLK_i),
                              .RESET(RST_n_i),
                              .OE(EN_WM_R_i),
                              .W_0(W0_i),
			      .W_1(W1_i),
			      .W_2(W2_i),
                              .W_3(W3_i),
		                      .W_4(W4_i),
	                          .W_5(W5_i),
			                  .W_6(W6_i),
		                      .W_7(W7_i),
			                  .W_8(W8_i),
                                          .TH(TH_i));
      							  
    ACCELERATOR_CONTROLLER_EWRSKIP CONT(.CLK(CLK_i),
                                .RESET(RST_n_i),
                                .REGISTERS_OE(EN_REG_i),
				.ACTIVATIONS_MEMORY_OE(EN_AM_R_i),
				.WEIGHTS_MEMORY_OE(EN_WM_R_i),
				.OM_0_WE(EN_OM0_W_i),
				.OM_0_OE(EN_OM0_R_i),
				.OM_1_WE(EN_OM1_W_i),
				.OM_1_OE(EN_OM1_R_i),
				.OFFM_WE(EN_OFF_W_i),
				.OUT_MAP(EN_OFF_R_i));
                                //.END_SIM(END_SIM_i));
		  

         DATAPATH_HYBRID_EWS_APPS_MULTIPLICATION UUT(  .CLK(CLK_i),
	                .RESET(RST_n_i),
		        .PIXELS(PIX_i),
		        .WEIGHT0(W0_i),
		        .WEIGHT1(W1_i),
		        .WEIGHT2(W2_i),
		        .WEIGHT3(W3_i),
		        .WEIGHT4(W4_i),
		        .WEIGHT5(W5_i),
		        .WEIGHT6(W6_i),
		        .WEIGHT7(W7_i),
		        .WEIGHT8(W8_i),
                        .TH(TH_i),
		        .REGISTERS_ENABLE(EN_REG_i),
		        .OM_0_WRITE_ENABLE(EN_OM0_W_i),
                        .OM_0_READ_ENABLE(EN_OM0_R_i),
                        .OM_1_WRITE_ENABLE(EN_OM1_W_i),
                        .OM_1_READ_ENABLE(EN_OM1_R_i),
                        .MAP_RESULT_CHANNEL1(M_CH_1_i),
	                .MAP_RESULT_CHANNEL2(M_CH_2_i),
	                .MAP_RESULT_CHANNEL3(M_CH_3_i));



   OFF_CHIP_MEMORY_DRAM_CHANNEL1 OFF_CH1(.CLK(CLK_i),
	                                 .RESET(RST_n_i),
					 .WE(EN_OFF_W_i),
					 .OE(EN_OFF_R_i),
					 .DATA_INPUT(M_CH_1_i));
										 
   OFF_CHIP_MEMORY_DRAM_CHANNEL2 OFF_CH2(.CLK(CLK_i),
	                                 .RESET(RST_n_i),
					 .WE(EN_OFF_W_i),
					 .OE(EN_OFF_R_i),
					 .DATA_INPUT(M_CH_2_i));
										 
   OFF_CHIP_MEMORY_DRAM_CHANNEL3 OFF_CH3(.CLK(CLK_i),
	                                 .RESET(RST_n_i),
					 .WE(EN_OFF_W_i),
					 .OE(EN_OFF_R_i),
					 .DATA_INPUT(M_CH_3_i));
	
	
endmodule

		   