library IEEE;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_signed.all;

entity PE_STANDARD is
generic (n: integer; -- 9
         m: integer); --16
port( ACTIVATION: in std_logic_vector(n-1 downto 0);
      WEIGHT: in std_logic_vector(n-4 downto 0);
      PARTIAL_SUM: in std_logic_vector(m-1 downto 0);
      PARTIAL_RESULT: out std_logic_vector(m-1 downto 0));
end PE_STANDARD;

architecture behavioural of PE_STANDARD is

signal SIGNED_ACTIVATION: std_logic_vector(n downto 0);
signal PARTIAL_PRODUCT: std_logic_vector (m-1 downto 0);


begin

with ACTIVATION(n-1) select
SIGNED_ACTIVATION <= '0'&ACTIVATION when '0',
                     '1'&ACTIVATION when others;   
 
-- MULTIPLIER
PARTIAL_PRODUCT <= SIGNED_ACTIVATION*WEIGHT;

-- ADDITION
PARTIAL_RESULT <= PARTIAL_PRODUCT + PARTIAL_SUM;

end behavioural;

