library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;   
use ieee.std_logic_unsigned.all;
use ieee.std_logic_textio.all;

library std;
use std.textio.all;

entity ACTIVATIONS_MEMORY_ROM is
generic (m: integer:=16384; n: integer:=9; k: integer:=27);
port(CLK: in std_logic;
     RESET: in std_logic;
     OE: in std_logic;
     DATA_OUTPUT: out std_logic_vector(k-1 downto 0));
end ACTIVATIONS_MEMORY_ROM;   

architecture behavioural of ACTIVATIONS_MEMORY_ROM is

type ROM_ARRAY is array (0 to m-1) of std_logic_vector(k-1 downto 0);        

impure function read_data_ROM return ROM_ARRAY is                   
     
    file fp_R: text open READ_MODE is "/home/thesis/erik.anzalone/SYNTHESIS/ZEROSKIPPING_ARCHITECTURE/INPUTS/INPUTS3/image_CHANNEL1.txt";
    file fp_G: text open READ_MODE is "/home/thesis/erik.anzalone/SYNTHESIS/ZEROSKIPPING_ARCHITECTURE/INPUTS/INPUTS3/image_CHANNEL2.txt";
    file fp_B: text open READ_MODE is "/home/thesis/erik.anzalone/SYNTHESIS/ZEROSKIPPING_ARCHITECTURE/INPUTS/INPUTS3/image_CHANNEL3.txt";
	    variable buf_R: line;					     				 
	    variable buf_G: line;					     				 
	    variable buf_B: line;					     				 
	    variable valore_R : std_logic_vector (n-2 downto 0);
            variable valore_G : std_logic_vector (n-2 downto 0);
            variable valore_B : std_logic_vector (n-2 downto 0);		     
	    variable ROM: ROM_ARRAY :=(others=>(others=>'0'));	         
        variable readvalue_R: std_logic_vector(n-2 downto 0);
        variable readvalue_G: std_logic_vector(n-2 downto 0);
        variable readvalue_B: std_logic_vector(n-2 downto 0);
        variable readvalue_R_EXT: std_logic_vector(n-1 downto 0);
        variable readvalue_G_EXT: std_logic_vector(n-1 downto 0);
        variable readvalue_B_EXT: std_logic_vector(n-1 downto 0);		
        variable wordmemory: std_logic_vector(k-1 downto 0):=(others => '0');        
        variable I: integer range 0 to m;
        

begin
	readloop: for t in 0 to m-1 loop
       
               readline(fp_R, buf_R); -- Legge il valore puntato da fp_R e lo memorizza in buf_R
	           readline(fp_G, buf_G); -- Legge il valore puntato da fp_Y e lo memorizza in buf_Y
	           readline(fp_B, buf_B); -- Legge il valore puntato da fp_B e lo memorizza in buf_B
			   
			   hread(buf_R, valore_R);	--Il valore in buf_R  esadecimale e viene convertito in std_logic_vector 
			   hread(buf_G, valore_G);	--Il valore in buf_Y  esadecimale e viene convertito in std_logic_vector 
			   hread(buf_B, valore_B);	--Il valore in buf_B  esadecimale e viene convertito in std_logic_vector 
			   
                           readvalue_R:= std_logic_vector(unsigned(valore_R));
			   readvalue_G:= std_logic_vector(unsigned(valore_G));
			   readvalue_B:= std_logic_vector(unsigned(valore_B));
       

                           readvalue_R_EXT:= '0'&readvalue_R;
			   readvalue_G_EXT:= '0'&readvalue_G;
			   readvalue_B_EXT:= '0'&readvalue_B;
	
      -- WRITING WORD MEMORY THAT CONTAINS PIXELS OF RED, YELLOW, BLUE MATRIX		   
                wordmemory(k-1 downto k-n):= readvalue_R_EXT;         
               wordmemory(k-n-1 downto k-n-n):= readvalue_G_EXT;    
	       wordmemory(k-n-n-1 downto 0):= readvalue_B_EXT; 
               	
               ROM(I):= wordmemory;	
               I := I+1; 
                         
	end loop readloop;
	return ROM;
end function;
	

constant ROM: rom_array:= read_data_ROM;

-- reading process from ACTIVATIONS MEMORY( 3 pixel x clock cycle)

begin

	read_process: process (CLK,RESET,OE)  

	variable address : integer range 0 to m;
	begin
		if RESET = '1' then
			 address := 0;
			 DATA_OUTPUT <= (others=>'0');
		elsif (CLK'event and CLK = '1') then
               
			 if OE = '1' then
                 if (address < m) then
			     DATA_OUTPUT <= ROM(address); 
		             address := address + 1 ;				
				 else 
		                address:= 0;
	                         
			   end if;                                  
        end if;
end if;    
	
    end process read_process;
       

end behavioural;
	
