library IEEE;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_signed.all;

entity INPUT_ZERO_RECOGNIZER is
generic (n: integer); --9
port( ACTIVATION: in std_logic_vector(n-1 downto 0);
      WEIGHT: in std_logic_vector(n-4 downto 0);
      ZERO: out std_logic);
end INPUT_ZERO_RECOGNIZER ;

architecture behavioural of INPUT_ZERO_RECOGNIZER is

signal ACT_CONTROL: std_logic;
signal WEIGHT_CONTROL: std_logic;
begin


ACT_CONTROL <= '0' when ACTIVATION = "000000000" else
               '1';

WEIGHT_CONTROL <= '0' when WEIGHT = "000000" else 
                  '1';

ZERO <= ACT_CONTROL and WEIGHT_CONTROL;

end behavioural;